#!/bin/csh -f
set target = $1
#
# get compiler information
#
setenv FORTRAN_COMPILER `${F77} -v |& grep -i version`
cat > test_exec.f <<EOF
        program test
        end
EOF
${F77} -o test_exec test_exec.f

setenv FMOSFLM_EXEC `file test_exec | sed 's/test_exec: //'`
/bin/rm -f test_exec.f test_exec
# echo to add doubles quotes - can't work out how to do this otherwise
setenv compiler `echo \"$F77\"`
setenv cversion `echo \"$FORTRAN_COMPILER\"`
setenv fmosflm_exec `echo \"$FMOSFLM_EXEC\"`

if ( $target == 'replace' ) then
    goto replace
else
    goto revert
endif
exit
replace:
echo I\'m replacing stuff
sed -i -e "s;// Fortran compiler; strcpy(compiler,$compiler);" datetime.c
sed -i -e "s;// Compiler version; strcpy(cversion,$cversion);" datetime.c
sed -i -e "s;// Executable type; strcpy(mosflm_exec,$fmosflm_exec);" datetime.c
exit
revert:
echo I\'m putting it all back
#
# change datetime.c back again
#
sed -i -e "s; strcpy(compiler,$compiler);// Fortran compiler;" datetime.c
sed -i -e "s; strcpy(cversion,$cversion);// Compiler version;" datetime.c
sed -i -e "s; strcpy(mosflm_exec,$fmosflm_exec);// Executable type;" datetime.c

exit
